require "us"

explodeRate = 20
explodeSize = 50

function love.load()
	us.bases.left = us.addBase()
	us.bases.right = us.addBase()
	if us.bases.left.x > us.bases.right.x then
		us.bases.left, us.bases.right = us.bases.right, us.bases.left
	end
	
	explosions = {}

	trailImg = love.graphics.newImage('fire.png')
	
	explosionShader = love.graphics.newShader[[
		extern Image explosionCanvas;
		vec4 effect( vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords ){
			vec4 pixel = Texel(texture, texture_coords );
			screen_coords.x = screen_coords.x / love_ScreenSize.x;
			screen_coords.y = screen_coords.y / love_ScreenSize.y;
			vec4 canvasPixel = Texel(explosionCanvas, screen_coords);
			if (canvasPixel.r != 0) {
				pixel.r = 0;
			} else {
				pixel.r = 1.0;
			}
			return pixel;
		}
	]]
	
	explosionCanvas = love.graphics.newCanvas()
end

function love.update(dt)
	if love.mouse.isDown(1) then
		us.bases.left:fire()
	end
	if love.mouse.isDown(2) then
		us.bases.right:fire()
	end

	for _,b in pairs(us.bases) do
		b.cooldown = b.cooldown - 1
	end
	
	for i,b in pairs(us.bullets) do
		if (b.vx > 0 and b.x >= b.tx) or (b.vx < 0 and b.x < b.tx) then
			us:explode(b.x,b.y)
			table.remove(us.bullets, i)
		elseif (b.vy > 0 and b.y >= b.ty) or (b.vy < 0 and b.y < b.ty) then
			us:explode(b.x,b.y)
			table.remove(us.bullets, i)
		end
		--[[
		if b.x < -20 or b.x > love.graphics.getWidth() + 20 then
			table.remove(us.bullets, i)
		end
		if b.y < -20 or b.y > love.graphics.getHeight() + 20 then
			table.remove(us.bullets, i)
		end
		]]--
		b.x = b.x + b.vx*dt
		b.y = b.y + b.vy*dt
		b.trail:update(dt)
	end

	for i,e in pairs(explosions) do
		if e.embiggening then
			e.rad = e.rad + explodeRate * dt
			if e.rad >= explodeSize then
				e.embiggening = false
			end
		else
			e.rad = e.rad - explodeRate * dt
			if e.rad <= 0 then
				table.remove(explosions, i)
			end
		end
	end
end

function love.draw()
	love.graphics.setBackgroundColor(0,128,255)
	love.graphics.setColor(255,255,255)
	for _,b in pairs(us.bases) do
		love.graphics.circle("fill", b.x, b.y, 20, 6)
	end
	for _,b in pairs(us.bullets) do
		love.graphics.setColor(255,255,255)
		love.graphics.draw(b.trail, b.x, b.y)
		love.graphics.setColor(255,0,0)
		love.graphics.circle("fill", b.x, b.y, 5, 8)
	end
	love.graphics.setColor(255,255,0)
	love.graphics.setCanvas(explosionCanvas)
	love.graphics.clear()
	love.graphics.setBlendMode("replace")
	love.graphics.setShader(explosionShader)
	for _,e in pairs(explosions) do
		explosionShader:send("explosionCanvas",explosionCanvas)
		love.graphics.circle("fill", e.x, e.y, e.rad, 32)
	end
	love.graphics.setCanvas()
	love.graphics.setShader()
	love.graphics.setBlendMode("alpha")
	love.graphics.draw(explosionCanvas)
end
